SystemOrganization addCategory: #'Pier-PersistencyManager'!

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:47'!
renameSetUp

kernel := PRKernel named: '####test'.! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:48'!
renameTearDown

PRKernel instances removeAll: (PRKernel instances select: [ :k | k name beginsWith: '####' ]).! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:52'!
testRenameKernel

	self kernel persistency renameKernelTo: '####new'.

	self assert: kernel name = '####new'.

	self assert: (kernel == (PRKernel instanceNamed: '####new')).
	self assert: (self kernelNames includes: '####new').
	self deny: (self kernelNames includes: '####test').

 ! !

!PRPersistencyTest methodsFor: '*pier-persistencymanager' stamp: 'kph 4/21/2007 06:47'!
testRenameKernelFailDueToNameTaken

	| k | 

	k := PRKernel named: '####new'.

	self should: [ kernel persistency renameKernelTo: '####new' ] raise: Error.

	self assert: (k == (PRKernel instanceNamed: '####new') )

 ! !

WADispatcherPlugin subclass: #PRSeasideDispatcherPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:45'!
controlPanelClass

	^ PRPierControlPanel 	! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:50'!
execute 

	self requestor call:  (self controlPanelClass forApplication: self target)! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/26/2007 20:22'!
isActive 
	^ target isApplication and: 
		[ target configuration allAttributes anySatisfy: [ :c | c group = #pier]  ]! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/26/2007 21:57'!
label

	^ 'Pier'! !

!PRSeasideDispatcherPlugin methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 03:50'!
priority

	^ 350! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 11/15/2007 19:28'!
copyKernelTo: newName

| nameAvailable newRoot |

nameAvailable := [ PRKernel instanceNamed: newName ] on: Error do: [ true ].

nameAvailable == true ifFalse: [ ^ self error: 'name already exists in PRKernel instances' ].

newRoot := self kernel root copy.

PRKernel named: newName root: newRoot.

	newRoot incomingReferences
		toAll: (newRoot enumerator
			everything contents);
		do: [ :each | each update ].! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 2/27/2007 12:37'!
discarded! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 10/6/2006 07:34'!
exportTo: aPersistency 
 
^ (aPersistency fromPRPersistency: self).! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 05:03'!
exportToPRPersistency: aPRPersistency

! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 06:23'!
fromPRMagmaPersistency: aMagmaPersistency 

^aMagmaPersistency exportToPRPersistency: self  ! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 9/30/2006 06:20'!
fromPRPersistency: aPersistency 

^self copySameFrom: aPersistency! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 11/15/2007 15:23'!
renameKernelTo: newName
 
"although renaming a kernel is straightforward, using this api
 allows persistency mechanisms to maintain their integrity"

self validateNameAvailable: newName.

self kernel name: newName.! !

!PRPersistency methodsFor: '*pier-persistencymanager' stamp: 'kph 11/15/2007 15:23'!
validateNameAvailable: newName

| nameAvailable |
 
nameAvailable := [ PRKernel instanceNamed: newName ] on: Error do: [ true ].

nameAvailable == true ifFalse: [ ^ self error: 'name already exists in PRKernel instances' ].
 ! !

WADecoration subclass: #PRCurrentContextDecoration
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:30'!
context

	^ context ! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:52'!
isGlobal
	^ true! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:43'!
nextPresentersDo: aBlock

	PRCurrentContext use: self during: [
	
		aBlock value: self owner
	]
	! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:26'!
processChildCallbacks: aStream

	PRCurrentContext use: self during: [ super processChildCallbacks: aStream ]! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:25'!
renderContentOn: html

	PRCurrentContext use: self during: [
		self renderOwnerOn: html
	]
	! !

!PRCurrentContextDecoration methodsFor: 'as yet unclassified' stamp: 'kph 12/12/2007 21:29'!
setContext: c

	context := c! !

WADispatcherControlPanel subclass: #PRPierControlPanel
	instanceVariableNames: 'newKernelName context newPersistency'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-PersistencyManager'!

!PRPierControlPanel commentStamp: 'kph 10/3/2006 02:12' prior: 0!
This class provides a seaside configuration tool for pier.!

!PRPierControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:13'!
initialize
	"for seaside version<=2.7"
 
	 ^ self register! !

!PRPierControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:13'!
label

 ^ 'Pier'
 
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 12/12/2007 22:01'!
callWidget: widget  titled: title

     self call: (widget
   			addDecoration: (PRCurrentContextDecoration new setContext: self context; yourself);
   	         addDecoration: (WAWindowDecoration new
    	            title: title;
 			   yourself);		

			yourself) 
 
	 ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:06'!
confirmSetPersistency 
 
	| old new |
	
	(old := self kernelBeingServed persistency class) = (new := newPersistency class) ifTrue: [ ^false ].

	^ self confirm: ('Are you sure you want to replace ', old name , ' with ', new name) 

 ! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 03:01'!
context

	| kernel |

	kernel := self kernel.
 
	^context := (PRContext kernel: kernel ) 
					setUser: kernel adminUser;
					yourself.	

 	
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 11/15/2007 14:55'!
doCopyKernel: aKernel

	| newName |

	newName := self call: (WAInputDialog new label: 'new name').

	self usingAppSession: [ 

		[ self kernelBeingServed persistency copyKernelTo: newName ] 
			on: Error 
			do: [ :e | self inform: 'Copy failed: ', e messageText ]. 

	]. ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:12'!
doDeleteKernel: aKernel

	self	doubleConfirm: ('delete kernel: ', aKernel name)
		thenDo: [ PRKernel instances remove: aKernel ] ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 4/20/2007 00:40'!
doNewKernel

	self newKernelName ifNotEmpty: [  
		PRKernel instances detect: [ :k | k name = newKernelName ] ifNone: [ PRKernel named: newKernelName ]. 
	]! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:11'!
doRenameKernel: aKernel

	| newName |

	newName := self call: (WAInputDialog new label: 'new name').

	self usingAppSession: [ 

		[ self kernelBeingServed persistency renameKernelTo: newName ] 
			on: Error 
			do: [ :e | self inform: 'Rename failed: ', e messageText ]. 

	]. ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 7/27/2007 00:09'!
doSetKernelToServeTo: k

	(k isKindOf: PRKernel)
		ifTrue: [ self application preferenceAt: #kernel put: k.
				 self application preferenceAt: #mainClass put: PRPierMain ]
		ifFalse: [ self application preferenceAt: #mainClass put: PRPierMain classForServingAllKernels ].
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 4/20/2007 01:02'!
doSetPersistency 

	| kernel |

	kernel := self kernelBeingServed.

	self usingAppSession: [ 

		[   
			newPersistency := kernel persistency exportTo: newPersistency
		] 
		on: Error 
		do: [ :e | ^self error:  'Conversion failed: ', e messageText ].
	].


	(self confirm: 'Conversion succeeded, commit?') 
		ifFalse: [ self usingAppSession: [ newPersistency discarded ]. ^self  ].

	self usingAppSession: [ 
 		kernel persistency: newPersistency.
	].

	"ensure no-one can use stale data"
	self application clearHandlers
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/3/2006 15:07'!
done

^self answer! !

!PRPierControlPanel methodsFor: 'utilities' stamp: 'kph 9/30/2006 03:24'!
doubleConfirm: message thenDo: aBlock

((self confirm: 'Are you sure you want to ', message) and: 
	[ self confirm: 'Are you REALLY sure you want to ', message ])
	ifTrue: [ 
				^aBlock value.
	].
! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 7/27/2007 00:28'!
isApplicationServingAllKernels

	| mainClass |
	
	mainClass := self application preferenceAt: #mainClass.
	
	(mainClass respondsTo: #isServingAllKernels) ifFalse: [ ^ false ].
	
	^ mainClass isServingAllKernels
			 ! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 03:53'!
kernel

	^  self kernelBeingServed realize.
 
	 ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 7/27/2007 00:00'!
kernelBeingServed

	^ self isApplicationServingAllKernels 
		ifTrue: [ 'All Kernels' ] 
		ifFalse: [ self application preferenceAt: #kernel ]. ! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:17'!
manageGroups

	self callWidget: PUGroupsWidget new
		titled: 'Groups for ', self kernelBeingServed asString! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:15'!
manageSystem

	self callWidget: PUSystemWidget new
		titled: 'System'! !

!PRPierControlPanel methodsFor: 'actions' stamp: 'kph 10/19/2006 01:17'!
manageUsers

	self callWidget: PUUsersWidget new 
		titled: 'Users for ', self kernelBeingServed asString! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 10/4/2006 00:25'!
newKernelName

^newKernelName ifNil: [ '' ]! !

!PRPierControlPanel methodsFor: 'accessing' stamp: 'kph 10/4/2006 00:26'!
newKernelName: aString

newKernelName := aString! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 10/19/2006 01:02'!
renderContentOn: html

html form: [
	
	self renderKernelSelectorOn: html.
  		 
	html break.
	
	self isApplicationServingAllKernels ifFalse: [
		self renderManageUsersOn: html.

		html break.
	
		self renderPersistencyOn: html.

		html break.
	].
	
	self renderKernelsOn: html.
	self renderMiscOn: html.

	html horizontalRule.
 
	html submitButton on:#done of: self.
].! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 11/15/2007 14:55'!
renderKernelInstance: kernel on: html
 
| |

html tableData: [ html text: kernel name ].

html tableData: [ 
		html small: [ html anchor callback: [ self doDeleteKernel: kernel ] ; text: '(delete)' ] 
].

html tableData: [ 
		html small: [ html anchor callback: [ self doCopyKernel: kernel ] ; text: '(copy)' ] 
].

html tableData: [ 
	html text:  kernel persistency class.
].
 

 ! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 8/2/2007 19:14'!
renderKernelSelectorOn: html 

| list |

html heading level: 4; with: 'Serving:'.

list := PRKernel instances asOrderedCollection.
list add: 'All Kernels'.

html select
	selected: self kernelBeingServed;
	list: list;
	beSubmitOnChange;
	callback: [ :k | self doSetKernelToServeTo: k ].

self isApplicationServingAllKernels ifFalse: [ 
	html space.
	
	html small: [ 
		html anchor callback: [ self doRenameKernel: self kernelBeingServed ];
					with: '(rename)'.
	]
].! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 11/15/2007 15:17'!
renderKernelsOn: html

html heading level:4 ; with: 'Kernels:'.

html table id: 'kernels'; with: [
	PRKernel instances  do: [ :item | 
		html tableRow: [
			self renderKernelInstance: item on: html
		].
	].
].

html textInput size: 10;
	 on: #newKernelName of: self. 
	html submitButton callback: [ self doNewKernel ] ; text: 'New Kernel'.! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 12/12/2007 21:59'!
renderManageUsersOn: html
 
	(self kernelBeingServed respondsTo: #users) ifFalse: [ ^self ].

	html heading level: 4; with: 'Security:'.

	html submitButton on: #manageUsers of: self.
	html submitButton on: #manageGroups of: self.
 
  ! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 10/18/2006 12:53'!
renderMiscOn: html

Smalltalk at: #PUSystemWidget ifAbsent: [ ^self ].

html heading level: 4; with: 'System:'.

html submitButton on: #manageSystem of: self.
 	 
 	! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 10/3/2006 02:00'!
renderPRFilePersistency: persistency kernel: kernel on: html
 
html text: ' directory: '.
html textInput 
	size: 25; 
	value: persistency directory fullName;
	callback: [ :v | persistency setDirectory: 
			(FileDirectory on: (FileDirectory default fullNameFor: v)) ];
	yourself.

^true! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 2/27/2007 12:43'!
renderPRImagePersistency: persistency kernel: kernel on: html
 
html text: ' image: '.
html text: SmalltalkImage current imageName.
html text: ' duration: '.
html textInput 
	size: 10; 
	value: persistency duration asSeconds;
	callback: [ :v | persistency duration: v asInteger seconds ];
	yourself.
^true! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 10/4/2006 00:14'!
renderPersistency: persistency kernel: kernel on: html

| selector |
 
persistency ifNil: [ ^false ].

selector := ('render', persistency class name, ':kernel:on:') asSymbol.

^(self respondsTo: selector) ifTrue: [ self perform: selector with: persistency with: kernel with: html ]
	ifFalse: [ true ] 

 ! !

!PRPierControlPanel methodsFor: 'rendering' stamp: 'kph 10/19/2006 01:07'!
renderPersistencyOn: html
 
| selected |
 
self kernelBeingServed ifNil: [ ^self ].

html heading level: 4; with: 'Persistency:'.

selected :=  self kernelBeingServed persistency.
html select 
		list: (PRPersistency allSubclasses);
		selected: (newPersistency ifNil: [ selected ]) class ;
		callback: [ :chosenPersistencyClass | 
			newPersistency := (chosenPersistencyClass = selected class) 
				ifTrue: [ nil ]
				ifFalse: [ chosenPersistencyClass new ]
			];
		beSubmitOnChange;
		yourself.	 

 	(( selected class ~= newPersistency class)
		and: [ self renderPersistency: newPersistency kernel: self kernelBeingServed on: html ]) 
			ifTrue: [ 
					html submitButton callback: [ self confirmSetPersistency ifTrue: [ self doSetPersistency ] ]; text: 'Migrate'.
			].

^true
		 ! !
PRPierControlPanel initialize!
